// var
var myListener = new Object();
var ogg_mp3, stream_file, new_play, play_url, play_title;
var seek_s = 100;

// init
myListener.onInit = function() {
  this.position = 0;
};

// display playbuttons in page
for (var i = 0; i < document.getElementsByName("playmp3").length; i++) {
  document.getElementsByName("playmp3")[i].style.display = "inline";
}

// write playercontrol
document.write('<div id="playercontrol"><hr id="playercharge" noshade="noshade" /><hr id="playerposition" noshade="noshade" /><div id="playpause"><img id="play" src="http://refugeesemancipation.de/radio/play/play.png" alt="play" title="play" onclick="playIt()" /><img id="pause" src="http://refugeesemancipation.de/radio/play/pause.png" alt="pause" title="pause" onclick="pauseIt()" /></div><div id="stopdiv"><img id="stop" src="http://refugeesemancipation.de/radio/play/stop.png" alt="stop" title="stop" onclick="stopIt()" /></div><div id="seekdiv"><img id="seekbw" src="http://refugeesemancipation.de/radio/play/seekbw.png" alt="&lt;&lt;" title="seek backward 100s" onclick="seekBw()" /><img id="seekdecrease" src="http://refugeesemancipation.de/radio/play/down.png" alt="-" title="decrease seek amount" onclick="seekDecrease()" /><img id="seekincrease" src="http://refugeesemancipation.de/radio/play/up.png" alt="+" title="increase seek amount" onclick="seekIncrease()" /><img id="seekfw" src="http://refugeesemancipation.de/radio/play/seekfw.png" alt="&gt;&gt;" title="seek forward 100s" onclick="seekFw()" /></div></div>');

// functions
// write players
function writePlayer() {
  if (ogg_mp3 == "ogg") {
    alert("writePlayer() for ogg not jet implemented!");
  } else {
    document.getElementById("player").innerHTML = '<!--[if IE]><script type="text/javascript" event="FSCommand(command,args)" for="myFlash">eval(args);</script><![endif]--><object id="myFlash" type="application/x-shockwave-flash" data="http://refugeesemancipation.de/radio/play/player_mp3_js.swf" width="1" height="1"><param name="movie" value="http://refugeesemancipation.de/radio/play/player_mp3_js.swf" /><param name="AllowScriptAccess" value="always" /><param name="FlashVars" value="listener=myListener&amp;interval=500&amp;byteslimit=172800000" /></object>';
  }
}

// display playercontrol
function displayPlayerControl() {
  if (stream_file == "stream") {
    document.getElementById("playpause").style.display = "none";
  } else {
    document.getElementById("playpause").style.display = "inline";
  }
  document.getElementById("playercharge").style.width = "0%";
  document.getElementById("playerposition").style.width = "0%";
  document.getElementById("playercontrol").style.display = "block";
}

// update playercontrol mp3
myListener.onUpdate = function() {
  var total_bytes = this.bytesTotal;
  if (total_bytes == 0) total_bytes = 1;
  if (total_bytes == "undefined") total_bytes = 1;
  var load_percent = (Math.round(this.bytesLoaded / total_bytes * 1000) / 10);
  document.getElementById("playercharge").style.width = load_percent + "%";
  var duration_ms = this.duration;
  if (duration_ms == 0) duration_ms = 1;
  document.getElementById("playerposition").style.width = (Math.round(load_percent * this.position / duration_ms * 10) / 10) + "%";
  var is_playing = (this.isPlaying == "true");
  document.getElementById("play").style.display = (is_playing)?"none":"inline";
  document.getElementById("pause").style.display = (is_playing)?"inline":"none";
};

function playMp3(stream_file_new, play_url_new, play_title_new) {
  new_play = true;
  play_url = play_url_new;
  play_title = play_title_new;
  if (ogg_mp3 != "mp3") {
    ogg_mp3 = "mp3";
    writePlayer();
    setTimeout("playIt()", 1000);
  } else {
    playIt();
  }
  if (stream_file != stream_file_new) {
    stream_file = stream_file_new;
    displayPlayerControl();
  }
}

function playIt() {
  if (ogg_mp3 == "ogg") {
    alert("playIt() not jet implemented for ogg!");
    document.getElementById("play").style.display = "none";
    document.getElementById("pause").style.display = "inline";
  } else {
    if (new_play) {
      new_play = false;
      document.getElementById("myFlash").SetVariable("method:setUrl", play_url);
      document.getElementById("playercontrol").title = play_title;
    }
    document.getElementById("myFlash").SetVariable("method:play", "");
    document.getElementById("myFlash").SetVariable("enabled", "true");
  }
}

function pauseIt() {
  if (ogg_mp3 == "ogg") {
    alert("pauseIt() not jet implemented for ogg!");
    document.getElementById("pause").style.display = "none";
    document.getElementById("play").style.display = "inline";
  } else {
    document.getElementById("myFlash").SetVariable("method:pause", "");
  }
}

function stopIt() {
  if (ogg_mp3 == "ogg") {
    alert("stopIt() not jet implemented for ogg!");
  } else {
    play_url = "http://refugeesemancipation.de/radio/play/silence-1s-mono-32vbr.mp3";
    playIt();
    document.getElementById("myFlash").SetVariable("method:stop", "");
    document.getElementById("playercontrol").style.display = "none";
  }
  document.getElementById("playercontrol").style.display = "none";
  stream_file = "";
}

function seekBw() {
  if (ogg_mp3 == "ogg") {
    alert("seekBw() not jet implemented for ogg!");
  } else {
    var n_p = eval(myListener.position) - (1000 * seek_s);
    if (n_p < 0) n_p = 0;
    document.getElementById("myFlash").SetVariable("method:setPosition", n_p);
  }
}

function seekFw() {
  if (ogg_mp3 == "ogg") {
    alert("seekFw() not jet implemented for ogg!");
  } else {
    var n_p = eval(myListener.position) + (1000 * seek_s);
    var m_p = eval(myListener.duration) - 500;
    if (n_p > m_p) n_p = m_p;
    document.getElementById('myFlash').SetVariable('method:setPosition', n_p);
  }
}

function seekDecrease() {
  seek_s = seek_s / 10;
  if (seek_s < 1) {
    seek_s = 1;
  } else {
    document.getElementById("seekbw").title = "seek backward " + seek_s + " s";
    document.getElementById("seekfw").title = "seek forward " + seek_s + " s";
  }
}

function seekIncrease() {
  seek_s = seek_s * 10;
  if (seek_s > 10000) {
    seek_s = 10000;
  } else {
    document.getElementById("seekbw").title = "seek backward " + seek_s + " s";
    document.getElementById("seekfw").title = "seek forward " + seek_s + " s";
  }
}

